Unit ID23R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, II21R2_p, II21R1_p;

procedure ID23R(var T :Array of Real; var A :Array of Real;
                N :Integer; K :Integer; X :Real;
                var S :Array of Real; ND :Integer;
                var R :Array of Real; var R1 :Array of Real);

implementation

procedure ID23R(var T :Array of Real; var A :Array of Real;
                N :Integer; K :Integer; X :Real;
                var S :Array of Real; ND :Integer;
                var R :Array of Real; var R1 :Array of Real);
var
NDERIV,KMID,ID,I,IPKMID,IDUMMY,MFLAG,KP1MN,LEFT,L,LEFTPL :Integer;
FKMID,DIFF :Real;
const
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
NDERIV := ND;
if ( NDERIV = 1 ) 
 then goto _2;
KMID := K;
for ID:=2 to NDERIV do
 begin
  KMID := KMID-1;
  FKMID := (KMID);
  for I:=ID to N do
   begin
    IPKMID := I+KMID;
    DIFF := T[IPKMID-1]-T[I-1];
    if ( DIFF <> ZERO ) 
     then A[(I-1)+(ID-1)*N] := (A[(I-1)+(ID-2)*N]-A[(I-2)+(ID-2)*N])/DIFF*
FKMID;
_1:
   end;
 end;
_2:
ID := Max0(Min0(NDERIV,K),1);
for IDUMMY:=1 to ID do
 begin
_3:
  S[IDUMMY-1] := ZERO;
 end;
II21R2(T,N+1,X,I,MFLAG);
if ( X < T[K-1] ) 
 then goto _8;
if ( MFLAG = 0 ) 
 then goto _5;
if ( X > T[I-1] ) 
 then goto _8;
_4:
if ( I = K ) 
 then goto _8;
I := I-1;
if ( X = T[I-1] ) 
 then goto _4;
_5:
KP1MN := K+1-ID;
II21R1(T,KP1MN,X,I,R,R1);
_6:
LEFT := I-KP1MN;
for L:=1 to KP1MN do
 begin
  LEFTPL := LEFT+L;
_7:
  S[ID-1] := R[L-1]*A[(LEFTPL-1)+(ID-1)*N]+S[ID-1];
 end;
ID := ID-1;
if ( ID = 0 ) 
 then goto _8;
KP1MN := KP1MN+1;
II21R1(T,KP1MN,X,I,R,R1);
goto _6;
_8:
end;

end.
