Unit II21R1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure II21R1(var T :Array of Real; K :Integer; X :Real;
                IL :Integer; var V :Array of Real;
                var R :Array of Real);

implementation

procedure II21R1(var T :Array of Real; K :Integer; X :Real;
                IL :Integer; var V :Array of Real;
                var R :Array of Real);
var
J,IPJ,IMJP1,JP1,L,JP1ML :Integer;
VMPREV,VM :Real;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
label
_1,_2,_3;
begin
J := 1;
V[0] := ONE;
if ( J >= K ) 
 then goto _3;
_1:
IPJ := IL+J;
R[0+(J-1)*2] := T[IPJ-1]-X;
IMJP1 := IL-J+1;
R[1+(J-1)*2] := X-T[IMJP1-1];
VMPREV := ZERO;
JP1 := J+1;
for L:=1 to J do
 begin
  JP1ML := JP1-L;
  VM := V[L-1]/(R[0+(L-1)*2]+R[1+(JP1ML-1)*2]);
  V[L-1] := VM*R[0+(L-1)*2]+VMPREV;
_2:
  VMPREV := VM*R[1+(JP1ML-1)*2];
 end;
V[JP1-1] := VMPREV;
J := JP1;
if ( J < K ) 
 then goto _1;
_3:
end;

end.
